from MoinMoin import wikiutil

Dependencies = []

def execute(macro, packages, long_text=True):
    """ Create an "Install" message

    @param macro: global macro object
    @param packages packages to install
    @param text formatting text

    @rtype: unicode
    @return: formatted "install" message
    """

    # install icon and alt text
    # This currently says "install foo" or "install foo, bar and baz".
    # To change it to say "install the package(s)...",
    # change the word "install" to "install the %(PACKAGE)s"
    # in both places.
    # 
    # %(PACAKGE) is replaced by "package" or "packages", depending on
    # %the number of packages to install.
    text = "[[apt:%(PACKAGE_LIST)s|{{attachment:IconsPage/Install.png|Click here to install %(ALT_TEXT)s}}]]"

    if long_text:
        # Prepend "_install the packages_ foo, bar, and baz" to the icon
        text = "[[InstallingSoftware#installing-a-package|install]] %(PACKAGE_NAMES)s " + text

    # construct strings of the form "'foo'", "'foo' and 'bar'", or "'foo', 'bar', and 'baz'":

    package_list = packages.split(',')
    # construct: "'foo"
    packages_alt  =  "'" + package_list[0]
    packages_text = "''" + package_list[0]

    # construct: "'foo', 'bar"
    for package in package_list[1:-1]:
        packages_alt  +=  "', '"  + package
        packages_text += "'', ''" + package

    if (1==len(package_list)):
        packages_word = "package"
    else:
        packages_word = "packages"

        # construct: "'foo', 'bar', and 'baz"
        if (2 == len(package_list)):
            packages_alt  +=  "' and ''" + package_list[-1]
            packages_text += "'' and ''" + package_list[-1]
        elif (2 < len(package_list)):
            packages_alt  +=  ", ' and ''" + package_list[-1]
            packages_text += ", '' and ''" + package_list[-1]

    # construct: "'foo', 'bar', and 'baz'"
    packages_alt  +=  "'"
    packages_text += "''"

    # Format and print the text
    request = macro.request
    return wikiutil.renderText(
        request,
        wikiutil.searchAndImportPlugin(request.cfg, "parser", request.page.pi['format']),
        text % {
            'PACKAGE'      : packages_word,
            'PACKAGE_NAMES': packages_text,
            'ALT_TEXT'     : packages_alt,
            'PACKAGE_LIST' : packages,
            },
        line_anchors=False)
